#!/usr/bin/env python
# -*- coding:utf-8 -*-


# ############################################################################
#  license :
# ============================================================================
#
#  File :        AlarmMail.py
#
#  Project :     Alarm Mail Notification
#
# This file is part of Tango device class.
# 
# Tango is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Tango is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Tango.  If not, see <http://www.gnu.org/licenses/>.
# 
#
#  $Author :      graziano.scalamera$
#
#  $Revision :    $
#
#  $Date :        $
#
#  $HeadUrl :     $
# ============================================================================
#            This file is generated by POGO
#     (Program Obviously used to Generate tango Object)
# ############################################################################

__all__ = ["AlarmMail", "AlarmMailClass", "main"]

__docformat__ = 'restructuredtext'

import PyTango
import sys
# Add additional import
#----- PROTECTED REGION ID(AlarmMail.additionnal_import) ENABLED START -----#
import smtplib
from email.mime.text import MIMEText
import mysql.connector
from mysql.connector import errorcode
from datetime import datetime, timedelta
import re
import json

#----- PROTECTED REGION END -----#	//	AlarmMail.additionnal_import

# Device States Description
# No states for this device


class AlarmMail (PyTango.Device_4Impl):
    """"""
    
    # -------- Add you global variables here --------------------------
    #----- PROTECTED REGION ID(AlarmMail.global_variables) ENABLED START -----#
    addressBook= {
        }
    att_conf_Map= {
        }
    att_conf_fqdn_Map= {
        }
    #----- PROTECTED REGION END -----#	//	AlarmMail.global_variables

    def __init__(self, cl, name):
        PyTango.Device_4Impl.__init__(self,cl,name)
        self.debug_stream("In __init__()")
        AlarmMail.init_device(self)
        #----- PROTECTED REGION ID(AlarmMail.__init__) ENABLED START -----#

        #----- PROTECTED REGION END -----#	//	AlarmMail.__init__
        
    def delete_device(self):
        self.debug_stream("In delete_device()")
        #----- PROTECTED REGION ID(AlarmMail.delete_device) ENABLED START -----#

        #----- PROTECTED REGION END -----#	//	AlarmMail.delete_device

    def init_device(self):
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        #----- PROTECTED REGION ID(AlarmMail.init_device) ENABLED START -----#
        for dest in self.receivers:
                self.addressBook[dest.split('=')[0]] = dest.split('=')[1]
	hdbpp=mysql.connector.MySQLConnection()
	try:
        	hdbpp = mysql.connector.connect(user=self.hdbpp_user, password=self.hdbpp_password, host=self.hdbpp_host, database=self.hdbpp_dbname)
		hdbppcursor = hdbpp.cursor(named_tuple=True)
		hdbppcursor.execute("SELECT att_name, att_conf_id FROM att_conf")
		word = '([a-zA-Z0-9\+\._\*\#\-\:]+)'
		for row in hdbppcursor:
			self.att_conf_fqdn_Map[row.att_name] = row.att_conf_id
			m = re.compile("tango://"+word+"/"+word+"/"+word+"/"+word+"/"+word).match(row.att_name)
			if m is not None:
				att=m.groups()[1]+"/"+m.groups()[2]+"/"+m.groups()[3]+"/"+m.groups()[4]
				#print("* TANGO_HOST:{tango_host} -> {att_name}: {att_conf_id}".format(
				#	tango_host=m.groups()[0],
				#	att_name=att,
				#	att_conf_id=row.att_conf_id
				#))
			else:
				att=row.att_name
				#print("* TANGO_HOST:default -> {att_name}: {att_conf_id}".format(
				#	att_name=att,
				#	att_conf_id=row.att_conf_id
				#))
			self.att_conf_Map[att] = row.att_conf_id
			
	except mysql.connector.Error as err:
		if err.errno == errorcode.ER_ACCESS_DENIED_ERROR:
			self.set_status("HDB++: wrong username or password")
		elif err.errno == errorcode.ER_BAD_DB_ERROR:
			self.set_status("HDB++: database not existing")
		else:
			self.set_status("HDB++: " + err)
        hdbpp.close()
        #----- PROTECTED REGION END -----#	//	AlarmMail.init_device

    def always_executed_hook(self):
        self.debug_stream("In always_excuted_hook()")
        #----- PROTECTED REGION ID(AlarmMail.always_executed_hook) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.always_executed_hook

    # -------------------------------------------------------------------------
    #    AlarmMail read/write attribute methods
    # -------------------------------------------------------------------------
    
    
    
            
    def read_attr_hardware(self, data):
        self.debug_stream("In read_attr_hardware()")
        #----- PROTECTED REGION ID(AlarmMail.read_attr_hardware) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.read_attr_hardware


    # -------------------------------------------------------------------------
    #    AlarmMail command methods
    # -------------------------------------------------------------------------
    
    def SendAlarm(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendAlarm()")
        #----- PROTECTED REGION ID(AlarmMail.SendAlarm) ENABLED START -----#  
        params= {
        }
        for param in argin.split(';'):
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                #print('looping param=' + param)
        #print(params)

        dtnow = datetime.now()
        dtstart = dtnow - timedelta(hours=24)
        dtnow = dtnow + timedelta(hours=1)
        stop_date = dtnow.strftime("%Y-%m-%d %H:%M:%S")
        start_date = dtstart.strftime("%Y-%m-%d %H:%M:%S")
	
        #values= {
        #}
        msg_link = ''
        alm_url=''
        att_conf_str = ''
        values=[]
        if len(self.egiga_url) > 0:
            if params['values'].startswith('{'):
                jsonval=json.loads(params['values'])
                for key, value in jsonval.iteritems():
                    values+=[key+'='+str(value).replace('"', '')]
            else:
                values=params['values'].split(',')
            for value in values:
                #values[value.split('=',1)[0]] = value.split('=',1)[1]
                att = value.split('=',1)[0]
                if len(att) == 0:
                    continue
                #print('looping value=' + value + ' len(value.split(''='',1)[0])=')
                print('looping value=' + value)
                #print(len(att))
                print('  -> ' + value.split('=',1)[0])
                word = '([a-zA-Z0-9\+\._\*\#\-\:]+)'
                #ind = r'\[[0-9]+\]);'
                ind = r'\[(.*?)\]'
                try:
                    m = re.compile("tango://"+word+"/"+word+"/"+word+"/"+word+"/"+word+ind).match(att) #match fqdn with ind
                    if m is not None:
                        att="tango://"+m.groups()[0]+"/"+m.groups()[1]+"/"+m.groups()[2]+"/"+m.groups()[3]+"/"+m.groups()[4]
                        att_conf_id=self.att_conf_fqdn_Map[att]
                    else:
                        m1 = re.compile(word+"/"+word+"/"+word+"/"+word+ind).match(value.split('=',1)[0]) #match NOT fqdn with ind
                        if m1 is not None:
                            att=m1.groups()[0]+"/"+m1.groups()[1]+"/"+m1.groups()[2]+"/"+m1.groups()[3]
                            att_conf_id=self.att_conf_Map[att]
                        else:
                            m2 = re.compile("tango://"+word+"/"+word+"/"+word+"/"+word+"/"+word).match(att) #match fqdn without ind
                            if m2 is not None:
                                att="tango://"+m2.groups()[0]+"/"+m2.groups()[1]+"/"+m2.groups()[2]+"/"+m2.groups()[3]+"/"+m2.groups()[4]
                                att_conf_id=self.att_conf_fqdn_Map[att]						
                            else:						#try NOT fqdn without ind
                                att=value.split('=',1)[0]
                                att_conf_id=self.att_conf_Map[att]
                    if len(att_conf_str) == 0:
                        att_conf_str = str(att_conf_id)+',1,1'
                    else:
                        att_conf_str += ';' + str(att_conf_id)+',1,1'

                except Exception, e:
                    print 'Cannot find att_conf_id for ', value
                    print e

        if len(att_conf_str) > 0:
            link = self.egiga_url+'&start='+start_date+'&stop='+stop_date+'&ts='+att_conf_str+'&show_error='
            msg_link = '<a href="'+link+'">'+link+'</a><br>'

        url=''
        try:
            url=params['url']
        except KeyError, e:
            url=''
            print e

        if len(url) == 0:
            if len(msg_link) == 0:
                    msg = MIMEText('NEW ALARM DETECTED: \nName:     ' +params['name'] + '\nMessage:  ' + params['msg'] + '\nValues:   ' + params['values'] + '\nFormula:  ' + params['formula'])
            else:
                    msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] + '<br>Message: &nbsp;&nbsp;' + params['msg'] + '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] + '<br>Formula: &nbsp;&nbsp;' + params['formula']+'<br><br>HDB++ eGiga link:<br><br>'+msg_link+'</p></body></html>','html')
        else:
            alm_url='<a href="'+url+'">'+url+'</a>'
            if len(msg_link) == 0:
                msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] + '<br>Message: &nbsp;&nbsp;&nbsp;&nbsp;' + params['msg'] + '<br>Alarm URL: &nbsp;' + alm_url + '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] + '<br>Formula: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['formula'],'html')
            else:
                msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] + '<br>Message: &nbsp;&nbsp;&nbsp;&nbsp;' + params['msg'] + '<br>Alarm URL: &nbsp;' + alm_url + '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] + '<br>Formula: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['formula']+'<br><br>HDB++ eGiga link:<br><br>'+msg_link+'</p></body></html>','html')

        msg['Subject'] = 'ALARMED ' + params['name'] + ' - ' + params['msg']
        msg['From'] = '"'+ self.email_name +'"<'+self.email_user+'>'
        groups = params['groups']
        receive = ''
        first = True
        for gr in groups.split('|'):
                #print('looping gr=' + gr)
                try:
                    #print('  -> address=' + self.addressBook[gr])
                    if first:
                            receive = receive + self.addressBook[gr]
                            first = False
                    else:
                            receive = receive + ',' + self.addressBook[gr]
                except KeyError, e:
                    print 'Cannot find email address for group ', gr
                    print e

        #print('msg to=' + receive)
        msg['To'] = receive
        #msg['To'] = self.addressBook[groups] + ','
        s = smtplib.SMTP(self.email_smtp)
        s.sendmail(self.email_user,msg["To"].split(","), msg.as_string())
        s.quit()        
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendAlarm
        
    def SendNormal(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendNormal()")
        #----- PROTECTED REGION ID(AlarmMail.SendNormal) ENABLED START -----#
        params= {
        }
        for param in argin.split(';'):
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                #print('looping param=' + param)
        #print(params)
        msg = MIMEText('RESTORED TO NORMAL CONDITION: \nName:    ' +params['name'] + '\nMessage: ' + params['msg'] + '\nValues:  ' + params['values'] + '\nFormula: ' + params['formula'])
        msg['Subject'] = 'RESTORED ' + params['name'] + ' - ' + params['msg']
        msg['From'] = '"'+ self.email_name +'"<'+self.email_user+'>'
        groups = params['groups']
        receive = ''
        first = True
        for gr in groups.split('|'):
            #print('looping gr=' + gr)
            try:
                #print('  -> address=' + self.addressBook[gr])
                if first:
                        receive = receive + self.addressBook[gr]
                        first = False
                else:
                        receive = receive + ',' + self.addressBook[gr]
            except KeyError, e:
                print 'Cannot find email address for group ', gr
                print e
        #print('groups split=' + groups.split('|'))
        #print('msg to=' + receive)
        msg['To'] = receive
        #msg['To'] = self.addressBook[groups] + ','
        s = smtplib.SMTP(self.email_smtp)
        s.sendmail(self.email_user,msg["To"].split(","), msg.as_string())
        s.quit()          
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendNormal
        
    def SendAlarmHDB(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendAlarmHDB()")
        #----- PROTECTED REGION ID(AlarmMail.SendAlarmHDB) ENABLED START -----#
        params= {
        }
        for param in argin.split(';'):
            params[param.split('=',1)[0]] = param.split('=',1)[1]
            #print('looping param=' + param)
        att_list=[]
        err_list=[]
        hdbppes=''
        print(params)
        word = '([a-zA-Z0-9\+\._\*\#\-]+)'
        word2 = '([a-zA-Z0-9\+\.\*\#\-]+)'
        m = re.compile(word+"/"+word+"/"+word+"/"+word).match(params['name'])
        if m is not None:
            hdbppes = m.groups()[0]+"/"+m.groups()[1]+"/"+m.groups()[2]
        else:
            m = re.compile("hdbppes_"+word2+"_"+word2).match(params['name'])
            if m is not None:
                hdbppes = "archiving/hdb++archiver/"+m.groups()[0]
        if len(hdbppes) > 0:
            dev = PyTango.DeviceProxy(hdbppes)
            try:
                #tmp_nok = dev.read_attribute("AttributeNokList")
                tmp_errs = dev.read_attribute("AttributeErrorList")
                tmp_list = dev.read_attribute("AttributeList")
                #nok_list = tmp_nok.value
                err_list = tmp_errs.value
                att_list = tmp_list.value
                #comb_list = map(lambda x,y:(x,y),att_list,err_list)
            except (DevFailed,ConnectionFailed,EventSystemFailed),e:
                print 'Error read_attribute: %s' % (e[0]['desc'])


        comb_list = map(lambda x,y:(x,y),att_list,err_list)
        msg_hdb = ''
        for iii in comb_list:
            if len(iii[1]) > 0:
                msg_hdb += iii[0]+'\n'+iii[1]+'\n\n'
        msg = MIMEText('NEW ALARM DETECTED: \nName:    ' +params['name'] + '\nMessage: ' + params['msg'] + '\nValues:  ' + params['values'] + '\nFormula: ' + params['formula']+'\n\nHDB++ Errors:\n\n'+msg_hdb)
        msg['Subject'] = 'ALARMED ' + params['name'] + ' - ' + params['msg']
        msg['From'] = '"'+ self.email_name +'"<'+self.email_user+'>'
        groups = params['groups']
        receive = ''
        first = True
        for gr in groups.split('|'):
                #print('looping gr=' + gr)
                try:
                    #print('  -> address=' + self.addressBook[gr])
                    if first:
                            receive = receive + self.addressBook[gr]
                            first = False
                    else:
                            receive = receive + ',' + self.addressBook[gr]
                except KeyError, e:
                    print 'Cannot find email address for group ', gr
                    print e
        #print('groups split=' + groups.split('|'))
        #print('msg to=' + receive)
        msg['To'] = receive
        #msg['To'] = self.addressBook[groups] + ','
        s = smtplib.SMTP(self.email_smtp)
        s.sendmail(self.email_user,msg["To"].split(","), msg.as_string())
        s.quit()        
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendAlarmHDB
        
    def SendAlarmPROCFS(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendAlarmPROCFS()")
        #----- PROTECTED REGION ID(AlarmMail.SendAlarmPROCFS) ENABLED START -----#
        params= {
        }
        for param in argin.split(';'):
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                #print('looping param=' + param)
        #print(params)

        dtnow = datetime.now()
        dtstart = dtnow - timedelta(hours=24)
        dtnow = dtnow + timedelta(hours=1)
        stop_date = dtnow.strftime("%Y-%m-%d %H:%M:%S")
        start_date = dtstart.strftime("%Y-%m-%d %H:%M:%S")
	
        #values= {
        #}
        msg_link = ''
        alm_url=''
        att_conf_str = ''
        values=[]
        if len(self.egiga_url) > 0:
            if params['values'].startswith('{'):
                jsonval=json.loads(params['values'])
                for key, value in jsonval.iteritems():
                    values+=[key+'='+str(value).replace('"', '')]
            else:
                values=params['values'].split(',')
            for value in values:
                #values[value.split('=',1)[0]] = value.split('=',1)[1]
                att = value.split('=',1)[0]
                if len(att) == 0:
                    continue
                #print('looping value=' + value + ' len(value.split(''='',1)[0])=')
                print('looping value=' + value)
                #print(len(att))
                print('  -> ' + value.split('=',1)[0])
                word = '([a-zA-Z0-9\+\._\*\#\-\:]+)'
                #ind = r'\[[0-9]+\]);'
                ind = r'\[(.*?)\]'
                try:
                    m = re.compile("tango://"+word+"/"+word+"/"+word+"/"+word+"/"+word+ind).match(att) #match fqdn with ind
                    if m is not None:
                        att="tango://"+m.groups()[0]+"/"+m.groups()[1]+"/"+m.groups()[2]+"/"+m.groups()[3]+"/"+m.groups()[4]
                        att_conf_id=self.att_conf_fqdn_Map[att]
                    else:
                        m1 = re.compile(word+"/"+word+"/"+word+"/"+word+ind).match(value.split('=',1)[0]) #match NOT fqdn with ind
                        if m1 is not None:
                            att=m1.groups()[0]+"/"+m1.groups()[1]+"/"+m1.groups()[2]+"/"+m1.groups()[3]
                            att_conf_id=self.att_conf_Map[att]
                        else:
                            m2 = re.compile("tango://"+word+"/"+word+"/"+word+"/"+word+"/"+word).match(att) #match fqdn without ind
                            if m2 is not None:
                                att="tango://"+m2.groups()[0]+"/"+m2.groups()[1]+"/"+m2.groups()[2]+"/"+m2.groups()[3]+"/"+m2.groups()[4]
                                att_conf_id=self.att_conf_fqdn_Map[att]						
                            else:						#try NOT fqdn without ind
                                att=value.split('=',1)[0]
                                att_conf_id=self.att_conf_Map[att]
                    if len(att_conf_str) == 0:
                        att_conf_str = str(att_conf_id)+',1,1'
                    else:
                        att_conf_str += ';' + str(att_conf_id)+',1,1'

                except Exception, e:
                    print 'Cannot find att_conf_id for ', value
                    print e

        if len(att_conf_str) > 0:
            link = self.egiga_url+'&start='+start_date+'&stop='+stop_date+'&ts='+att_conf_str+'&show_error='
            msg_link = '<a href="'+link+'">'+link+'</a><br>'
        url=''
        try:
            url=params['url']
        except KeyError, e:
            url=''
            print e

        if len(url) == 0:
            if len(msg_link) == 0:
                    msg = MIMEText('NEW ALARM DETECTED: \nName:     ' +params['name'] + '\nMessage:  ' + params['msg'] + '\nValues:   ' + params['values'] + '\nFormula:  ' + params['formula'])
            else:
                    msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] + '<br>Message: &nbsp;&nbsp;' + params['msg'] + '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] + '<br>Formula: &nbsp;&nbsp;' + params['formula']+'<br><br>HDB++ eGiga link:<br><br>'+msg_link+'</p></body></html>','html')
        else:
            alm_url='<a href="'+url+'">'+url+'</a>'
            if len(msg_link) == 0:
                msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] + '<br>Message: &nbsp;&nbsp;&nbsp;&nbsp;' + params['msg'] + '<br>Alarm URL: &nbsp;' + alm_url + '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] + '<br>Formula: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['formula'],'html')
            else:
                msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] + '<br>Message: &nbsp;&nbsp;&nbsp;&nbsp;' + params['msg'] + '<br>Alarm URL: &nbsp;' + alm_url + '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] + '<br>Formula: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['formula']+'<br><br>HDB++ eGiga link:<br><br>'+msg_link+'</p></body></html>','html')

        msg['Subject'] = 'ALARMED ' + params['name'] + ' - ' + params['msg']
        msg['From'] = '"'+ self.email_name +'"<'+self.email_user+'>'
        groups = params['groups']
        receive = ''
        first = True
        for gr in groups.split('|'):
                #print('looping gr=' + gr)
                try:
                    #print('  -> address=' + self.addressBook[gr])
                    if first:
                            receive = receive + self.addressBook[gr]
                            first = False
                    else:
                            receive = receive + ',' + self.addressBook[gr]
                except KeyError, e:
                    print 'Cannot find email address for group ', gr
                    print e
        #print('groups split=' + groups.split('|'))
        #print('msg to=' + receive)
        msg['To'] = receive
        #msg['To'] = self.addressBook[groups] + ','
        s = smtplib.SMTP(self.email_smtp)
        s.sendmail(self.email_user,msg["To"].split(","), msg.as_string())
        s.quit()        
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendAlarmPROCFS
        

    #----- PROTECTED REGION ID(AlarmMail.programmer_methods) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	AlarmMail.programmer_methods

class AlarmMailClass(PyTango.DeviceClass):
    # -------- Add you global class variables here --------------------------
    #----- PROTECTED REGION ID(AlarmMail.global_class_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	AlarmMail.global_class_variables


    #    Class Properties
    class_property_list = {
        }


    #    Device Properties
    device_property_list = {
        'receivers':
            [PyTango.DevVarStringArray, 
            "groupname=email",
            [] ],
        'email_name':
            [PyTango.DevString, 
            "email name",
            ["Control Alarms"] ],
        'email_smtp':
            [PyTango.DevString, 
            "SMTP server",
            ["smtp"] ],
        'email_user':
            [PyTango.DevString, 
            "email user",
            [] ],
        'hdbpp_user':
            [PyTango.DevString, 
             '',
            [] ],
        'hdbpp_password':
            [PyTango.DevString, 
             '',
            [] ],
        'hdbpp_host':
            [PyTango.DevString, 
             '',
            [] ],
        'hdbpp_dbname':
            [PyTango.DevString, 
             '',
            [] ],
        'egiga_url':
            [PyTango.DevString, 
            "eGiga url",
            [] ],
        }


    #    Command definitions
    cmd_list = {
        'SendAlarm':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendNormal':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendAlarmHDB':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendAlarmPROCFS':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        }


    #    Attribute definitions
    attr_list = {
        }


def main():
    try:
        py = PyTango.Util(sys.argv)
        py.add_class(AlarmMailClass, AlarmMail, 'AlarmMail')
        #----- PROTECTED REGION ID(AlarmMail.add_classes) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.add_classes

        U = PyTango.Util.instance()
        U.server_init()
        U.server_run()

    except PyTango.DevFailed as e:
        print ('-------> Received a DevFailed exception:', e)
    except Exception as e:
        print ('-------> An unforeseen exception occured....', e)

if __name__ == '__main__':
    main()
